<?php

    function getNotifiers(){
        $items = $match = array();

        $dir = PATH .'/modules/mod_yandex_table/notifiers';
        $pdir = opendir($dir);

        while ($nextfile = readdir($pdir)){
            if (
                ($nextfile != '.') &&
                ($nextfile != '..') &&
                !is_dir($dir .'/'. $nextfile) &&
                (substr($nextfile, 0, 3) == 'yt_') &&
                preg_match('#([a-z_]+)\.class\.php#is', $nextfile, $match)
            ){
                include(PATH .'/modules/mod_yandex_table/notifiers/'. $nextfile);
                $items[] = $match[1];
            }
        }

        return $items;
    }

    $id = cmsCore::request('id', 'int');
    $opt = cmsCore::request('opt', 'str', 'config');
    $notifiers = getNotifiers();
    
    cpAddPathway('Виджет Табло для яндекс браузера', '?view=modules&do=edit&id='. $id);
    cpAddPathway('Настройки', '?view=modules&do=config&id='. $id);
    
    echo '<h3>Виджет Табло для яндекс браузера</h3>';

    $cfg = $inCore->loadModuleConfig($id);
    
    if ($opt == 'save_config'){
        $cfg = array();
        $cfg['yt_version'] = cmsCore::request('yt_version', 'str', '1');
        $cfg['yt_api_version'] = cmsCore::request('yt_api_version', 'str', '1');
        $cfg['yt_color'] = cmsCore::request('yt_color', 'str', '000000');
        $cfg['yt_show_title'] = cmsCore::request('yt_show_title', 'int', '1');
        
        $yt_notifiers = array();
        foreach ($notifiers as $notice){
            $cfg['notifiers'][$notice .'_onoff'] = cmsCore::request($notice .'_onoff', 'int', 0);
            if ($cfg['notifiers'][$notice .'_onoff'] === 1){
                $yt_notifiers[] = $notice;
            }
        }
        
        if (!empty($_FILES['logofile']['name'])){
            cmsCore::moveUploadedFile($_FILES['logofile']['tmp_name'], PATH .'/upload/ya_logo.png', $_FILES['logofile']['error']);
        }
        
        $manifest = '{'. "\n";
        $manifest .= '    "version": "'. $cfg['yt_version'] .'",'. "\n";
        $manifest .= '    "api_version": '. $cfg['yt_api_version'] .','. "\n";
        $manifest .= '    "layout": {'. "\n";
        $manifest .= '        "logo": "'. HOST .'/upload/ya_logo.png",'. "\n";
        $manifest .= '        "color": "#'. $cfg['yt_color'] .'",'. "\n";
        $manifest .= '        "show_title": '. ($cfg['yt_show_title'] == 1 ? 'true' : 'false') . "\n";
        $manifest .= '    }'. (!empty($yt_notifiers) ? ',' : '') . "\n";
        if (!empty($yt_notifiers)){
            $manifest .= '    "feed": {'. "\n";
            $manifest .= '        "url": "'. HOST .'/modules/mod_yandex_table/feed.php?mod_id='. $id .'",'. "\n";
            $manifest .= '        "format": "json",'. "\n";
            $manifest .= '        "notifiers": ['. "\n";
            
            $manifest_notifiers = array();
            $manifest_notice = '';
            foreach ($yt_notifiers as $notice){
                $manifest_notice = '            {'. "\n";
                $manifest_notice .= '                "name": "'. $notice::$name .'",'. "\n";
                $manifest_notice .= '                "icon": "'. HOST . $notice::$icon .'"'. "\n";
                $manifest_notice .= '            }'. "\n";
                $manifest_notifiers[] = $manifest_notice;
            }
            $manifest .= implode(",\n", $manifest_notifiers) ."\n";
            $manifest .= '        ]'. "\n";
            $manifest .= '    }'. "\n";
        }
        
        $manifest .= '}';
        file_put_contents(PATH .'/upload/ya_manifest.json', $manifest);
        
        cmsCore::saveModuleConfig($id, $cfg);
        cmsCore::addSessionMessage('Настройки успешно сохранены', 'success');
        cmsCore::redirect('index.php?view=modules&do=config&id='. $id);
    }

    if ($opt == 'config'){
?>
<form action="index.php?view=modules&do=config&id=<?php echo $id; ?>&opt=save_config" method="post" name="optform" target="_self" id="optform" enctype="multipart/form-data">
    <div style="margin:10px 0 30px 0;">
        <a href="http://api.yandex.ru/tableau/doc/" target="_blank">
            Подробная информация о виджете Табло в яндекс браузере.
        </a>
    </div>
        <table width="600">
            <tr valign="top">
                <td width="300">
                    <strong><a href="javascript:$('#hinttext1').toggle();">Версия виджета сайта</a></strong>
                    <div id="hinttext1" class="hinttext" style="display:none;">
                        Номер версии манифест-файла. Обязательное поле.<br/>
                        Состоит из целых чисел от 0 до 65535 включительно, разделенных точкой.<br/>
                        Количество чисел в версии: до четырех включительно.<br/>
                        Недопустимо начинать многозначное число с нуля (то есть 32 нельзя указать как 032).<br/>
                        Примеры:<br/>
                        "version": "1"<br/>
                        "version": "1.0.1"<br/>
                        "version": "7.32.550"<br/>
                        "version": "90.2.3.65535"
                    </div>
                </td>
                <td>
                    <input type="text" name="yt_version" style="width:57px;" value="<?php echo $cfg['yt_version']; ?>" />
                </td>
            </tr>
            <tr valign="top">
                <td width="300">
                    <strong><a href="javascript:$('#hinttext2').toggle();">Версия API Яндекса</a></strong>
                    <div id="hinttext2" class="hinttext" style="display:none;">
                        Номер версии API Табло, с которой должен работать виджет. Обязательное поле.<br/>
                        Текущая версия API:<br/>
                        "api_version": 1
                    </div>
                </td>
                <td>
                    <input type="text" name="yt_api_version" style="width:57px;" value="<?php echo $cfg['yt_api_version']; ?>" />
                </td>
            </tr>
            <tr>
                <td width="300">
                    <strong>Цвет фона</strong>
                </td>
                <td>
                    #<input type="text" name="yt_color" style="width:50px;" value="<?php echo $cfg['yt_color']; ?>" />
                </td>
            </tr>
            <tr>
                <td width="300">
                    <strong>Отображение заголовка страницы сайта</strong>
                </td>
                <td>
                    <select name="yt_show_title" style="width:57px;">
                        <option value="1">Да</option>
                        <option value="0">Нет</option>
                    </select>
                </td>
            </tr>
            <tr valign="top">
                <td width="300">
                    <strong><a href="javascript:$('#hinttext3').toggle();">Нотификаторы</a></strong>
                    <div id="hinttext3" class="hinttext" style="display:none;">
                        На виджете сайта могут отображаться уведомления о событиях.<br/>
                        Например сколько статей добавилось за сегодня, сколько фотографий, сообщения и т.д<br/>
                        Отметьте события каких компонентов должны отображаться.<br/>
                        Количество нотификаторов не ограничено, однако на виджете могут быть отображены только первые три.
                    </div>
                </td>
                <td>
                    <?php
                    foreach ($notifiers as $notice){
                        echo '<label><input type="checkbox" name="'. $notice .'_onoff" value="1" '. (!empty($cfg['notifiers'][$notice .'_onoff']) ? 'checked="checked"' : '') .' />'. $notice::$title .'</label><br/>';
                    }
                    ?>
                </td>
            </tr>
            <tr>
                <td width="300">
                    <strong>Логотип</strong>
                    <div class="hinttext">
                        <img src="/upload/ya_logo.png" />
                    </div>
                </td>
                <td>
                    <input type="file" name="logofile" style="width:90%;" />
                </td>
            </tr>
        </table>
        <div style="margin-top:30px;">
            <input type="submit" value="Сохранить" />
        </div>
    </form>
<?php
    }
?>